# Extended NPC Spawn Attrition


## How to Use

**In Attrition gamemode, use the playlistvar** `aitdm_extended_spawns 1` **to enable extended NPC spawn contents**

**Please add** 

- `sv_max_props_multiplayer 500000` 
- `sv_max_prop_data_dwords_multiplayer 800000` 

**to startup args(add an extra **`+`** as prefix) or typing them in console before starting, otherwise the game might crash**


## Note

Due to weapon file modifications, this mod might be incompatible with weapon model modifications, highly recommand run on dedicated servers!

If you're not on dedicated servers, please enable `sv_cheats` and do `weapon_reparse` in console before starting the gamemode, disable `sv_cheats` after `weapon_reparse` is done


## Introduction

Similar to [GruntMode](https://northstar.thunderstore.io/package/VoyageDB_Modding_Home/Grunt_Mode) but players are pilots

Including fixes in [NessieTempFix](https://northstar.thunderstore.io/package/VoyageDB_Modding_Home/Nessie_Temp_Fix)( except gamemode fixes ), Needs testing!

Add Testing Classic Rodeo fix. Use the playlistvar `classic_rodeo 1` to enable fake Titanfall 1 style rodeo. Rodeo damage can be modified through playlistvar `classic_rodeo_damage_scale`

Add Classic Executions. Use the playlistvar `classic_execution 1` to enable fake Titanfall 1 style execution( overwrites first person executions )

**Score Events:**

Start with Specialist grunts spawning

- 80: Spectres spawning

- 150: Stalkers and Prowlers spawning

- 230: Reapers and Gunships spawning

- 330: Titans and NPC pilots spawning


## NPC Spawn Settings PlaylistVar

**PlaylistVar are variables those can be used in `setplaylistvaroverrides` command**

**They're also accessible in Private Match Settings menu( with localized display name )**

### Category: Attrition Extended(Overrides Attrition)

| **Variable** | **Display Name in Private Match** | **Description** | **Default value** | **Accepted Value** |
|:------------:|:---------------------------------:|:---------------:|:-----------------:|:------------------:|
| `aitdm_extended_spawns` | Enable Attrition Extended | If set to 1, overrides basic Attrition with extended npc spawns | `0` | 0-1 |
| `aitdm_extended_coop` | Attrition Extended COOP Variant | Requires `aitdm_extended_spawns 1`. If set to 1, enable COOP variant of Attrition Extended: All players at the same team against enemy NPCs | `0` | 0-1 |
| `aitdm_coop_team_boss_titans` | COOP: Boss Titan based On Player Team | Requires `aitdm_extended_coop 1`. If set to 1, enemy boss titan will spawn in specific team variant( eg. Ash, Blisk, Slone if player in TEAM_MILITIA; Jack, Sarah, Vanguard-Class if player in TEAM_IMC ) | `0` | 0-1 |
| `aitdm_coop_friendly_npc_percent` | COOP: Friendly NPC Percentage | Requires `aitdm_extended_coop 1`. The percentage of how many friendly NPCs will spawn( eg. 0.5 means there'll only be half of normal npc count on your team, 0.0 means there won't be any npc on your team ) | `0.7` | Any Positive Float value |
| `aitdm_coop_enemy_npc_min_percent` | COOP: Enemy NPC Percentage at Single Player | Requires `aitdm_extended_coop 1`. The percentage of how many enemy NPCs will spawn when you're the only player in server | `1.0` | Any Positive Float value |
| `aitdm_coop_enemy_npc_increment_per_player` | COOP: Enemy NPC Percentage Increment Per Player | Requires `aitdm_extended_coop 1`. The percentage added to `aitdm_coop_enemy_npc_min_percent` for each player in the game. Max percentage is `aitdm_coop_enemy_npc_max_percent` | `0.5` | Any Positive Float value |
| `aitdm_coop_enemy_npc_max_percent` | COOP: Enemy NPC Percentage at Max Increment | Requires `aitdm_extended_coop 1`. The max increment of npc percentage based on player count | `2.5` | Any Positive Float value |
| `aitdm_coop_pilot_score_multiplier` | COOP: Enemy Score Multiplier from Killing Pilots | Requires `aitdm_extended_coop 1`. For adding some challenge. When enemy NPC kills a player controlled pilot character, the score they get will be multiplied by this value( eg. 5.0 means enemy npcs will gain 25(5*5) score on killing your pilot, makes sometimes you can lose the game if not careful enough ) | `2.0` | Any Positive Float value |
| `aitdm_coop_titan_score_multiplier` | COOP: Enemy Score Multiplier from Killing Titans | Requires `aitdm_extended_coop 1`. For adding some challenge. When enemy NPC kills a player owned titan, the score they get will be multiplied by this value( eg. 8.0 means enemy npcs will gain 80(10*8) score on killing your pilot, makes sometimes you can lose the game if not careful enough ) | `3.0` | Any Positive Float value |

### Category: Modded Attrition Gamemode Spawn Settings

| **Variable** | **Display Name in Private Match** | **Description** | **Default value** | **Accepted Value** |
|:------------:|:---------------------------------:|:---------------:|:-----------------:|:------------------:|
| `modaitdm_squad_count` | Squads Per Team | How many infantry squads a team can have | `5` | Any Positive Int value |
| `modaitdm_squad_count_high_level` | Squads Per Team at Highter Score Level | When reaper starts deploying, `modaitdm_squad_count` will be replaced by this value | `3` | Any Positive Int value |
| `modaitdm_prowler_count` | Prowlers Per Team | How many prowlers a team can have | `4` | Any Positive Int value |
| `modaitdm_reaper_count` | Reapers Per Team | How many reapers a team can have | `2` | Any Positive Int value |
| `modaitdm_gunship_count` | Gunships Per Team | How many gunships a team can have | `2` | Any Positive Int value |
| `modaitdm_pilot_count` | NPC Pilots Per Team | How many npc pilots and their titans a team can have | `3` | Any Positive Int value |
| `modaitdm_spectre_spawn_score` | Spectre Score Level | How many score required to make enemy team start deploying spectres | `80` | Any Positive Int value |
| `modaitdm_stalker_spawn_score` | Stalker Score Level | How many score required to make enemy team start deploying stalkers and prowlers | `150` | Any Positive Int value |
| `modaitdm_reaper_spawn_score` | Reaper Score Level | How many score required to make enemy team start deploying reapers and gunships | `230` | Any Positive Int value |
| `modaitdm_titan_spawn_score` | Titan Score Level | How many score required to make enemy team start deploying npc pilots and their titans | `330` | Any Positive Int value |
| `modaitdm_boss_replace_chance` | Boss Titan Replace Chance | Chance of replacing a normal npc pilot titan spawn with boss titan spawn | `0.30` | Any Positive Float value |


### Full change log can be seen in `doc\changelog.md`